/*---------------------------------------------------------------------

microsphere.h

This file is part of CytoPacq

Copyright (C) 2007-2013 -- Centre for Biomedical Image Analysis (CBIA)

CytoPacq is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CytoPacq is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with CytoPacq. If not, see <http://www.gnu.org/licenses/>.

Author: David Svoboda

Description: A plugin creating the digital phantom of microsphere.

-------------------------------------------------------------------------*/

#ifndef _PHANTOM_MICROSPHERE_
#define _PHANTOM_MICROSPHERE_

#include "generic.h"

//------------------------------------------------------------------------
//
class phantom_microsphere : public phantom_with_position
{ 
  private:
			 // ---------- internal variables ------------
			 float diameter; // microsphere diameter (microns)

			 // ---------- internal methods --------------
			 template <class L>
			 bool _create_shape(i3d::Image3d<L> &);

			 template <class T, class L>
			 void _create_texture(const i3d::Image3d<L> &,
										 i3d::Image3d<T> &);

  public:
			 // ---------- public methods ------------------
			 virtual void read_params(const t_item_seq &,
											  const t_item_seq &);

			 virtual bool draw(i3d::Image3d<i3d::GRAY8>&, 
									 i3d::Image3d<LABEL_TYPE>&);

			 virtual bool draw(i3d::Image3d<i3d::GRAY16>&, 
									 i3d::Image3d<LABEL_TYPE>&);

			 /// virtual destructor
			 virtual ~phantom_microsphere() {};
};
//------------------------------------------------------------------------

#endif
