/*---------------------------------------------------------------------

illumination.h

This file is part of CytoPacq

Copyright (C) 2007,2008 -- Centre for Biomedical Image Analysis (CBIA)

CytoPacq is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CytoPacq is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with CytoPacq. If not, see <http://www.gnu.org/licenses/>.

Author: David Svoboda

Description: The simulation of the uneven illumination phenomenon.

Modification: 2012 - Luděk Matyska jr. - proper implementation of uneven illumination

-------------------------------------------------------------------------*/

#ifndef _ILLUMINATION_
#define _ILLUMINATION_

// i3d header
#include <i3d/image3d.h>
#include "sim_macros.h"

template <class VOXEL> void AddIllumination(
		i3d::Image3d<VOXEL> &img, // affected image
		float shiftx, // shift on x axis
		float shifty, // shift on y axis
		float *quadp); // the parameters of the quadratic function of uneven illumination

#endif
