/*---------------------------------------------------------------------

optigen.h

This file is part of CytoPacq

Copyright (C) 2007,2008 -- Centre for Biomedical Image Analysis (CBIA)

CytoPacq is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CytoPacq is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with CytoPacq. If not, see <http://www.gnu.org/licenses/>.

Author: David Svoboda

Description: A module responsible for optical system simulation (blur, uneven illumination).

-------------------------------------------------------------------------*/

#ifndef _OPTIGEN_
#define _OPTIGEN_

#include <i3d/image3d.h>
#include "ini/iniparser.h"

template <class VOXEL>
void CallOptigen(const IniHandler &params, 
					  i3d::Image3d<VOXEL> &image, 
					  float stretchFactor = 1.0f);

#endif
