#!/bin/bash

# check the number of in arguments
if [ $# != 1 ]; then
		  echo "clean_db.sh: This script requires one parameter!";
		  exit 1;
fi

RECORDS=20
PROCESSES=mktemp

# find the redundant (keep the $RECORD youngest) processes.
mysql -e "select pid from processes where start < (select start from processes order by start desc limit $RECORDS,1)" | tr "\n" " " | sed 's/pid//' > $PROCESSES

# track the individual processes
for ITEM in `cat $PROCESSES`; do
   # delete the record in the database
	echo "-> deleting $ITEM from the database"
	mysql -e "delete from processes where pid=\"$ITEM\""

   # deleting corresponding directory with its context
	if [ -d "$1/$ITEM" ]
	then
	  echo "-> deleting directory \"$1/$ITEM\""
	  rm -r "$1/$ITEM"
	fi
done

unlink $PROCESSES

exit 0;
